Description

Redmine is pretty prepared for a development mode, but with a plugins and patching concerned, there are a few blockers for it's

funcionality.

1. redmine/i18n is required in redmine.rb, but row above it is autoloaded by rails and thus both mechanisms are loading it. It is

problem in some of my patches. But it is basically bad idea to mix those behaviours. ( My vote goes for a rails autoloading... )

2. Redmine::Hook::Helper is in file, which is required, but is patching ApplicationHelper and that is loaded by Rails autoloading. So

its patch is forgotten after reloading

3. redmine/themes.rb defines ApplicationHelper, but it gets into problems, if there is a patch for it in plugin, which redefines

ApplicationHelper method. Rails do not load it - it is loaded, but does not have the method defined. It works only if patch is after

a controller invocation, because it load it by path and do not care if it is defined. But it bassically defines the model and avoiding

Rails autoloading.

I have created a patch for every issue I have found.

History

#1 - 2015-08-11 01:01 - Toshi MARUYAMA

- Status changed from New to Needs feedback

Please create new issues per patch.

#2 - 2015-08-11 02:01 - Ondřej Ezr

Done #20506, #20507 and #20508

#3 - 2015-08-18 10:10 - Toshi MARUYAMA

- Status changed from Needs feedback to Closed

Thank you.

Files

redmine_i18n_loaded_automaticaly.patch 377 Bytes 2015-07-12 Ondřej Ezr

themes_helper.patch 495 Bytes 2015-07-12 Ondřej Ezr

hook_availability_after_reload.patch 571 Bytes 2015-07-12 Ondřej Ezr
